﻿#Region Includes
#include <Array.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <File.au3>
#include <FileConstants.au3>
#include <GuiComboBox.au3>
#include <GUIConstantsEx.au3>
#include <GuiStatusBar.au3>
#include <GuiTreeView.au3>
#include <MsgBoxConstants.au3>
#include <WindowsConstants.au3>
#EndRegion Includes

#Region Optionen
Opt('MustDeclareVars', 1)
Opt('GUIOnEventMode', 1) ; auf den Event-Mode umschalten
#EndRegion Optionen

#Region Konstanten deklarieren
Global Const $sAppTitle = 'OSC Mailer'
Global Const $sAppVersion = '1.2.0.0'
Global Const $sAppDate = '13.03.2018'
Global Const $sAppAuthor = ''
Global Const $sMailerPath = @ScriptDir & '\Mailer\'
Global Const $iWidth = 800, $iHeight = 600
Global Const $OSC_NORMAL = 0, $OSC_ELEDIGT = 1, $OSC_RESERVIERT = 2, $OSC_WICHTIG = 4
#EndRegion Konstanten deklarieren

#Region Fenster erstellen
Global $hGui = GUICreate(StringFormat('%s  v%-3.3s', $sAppTitle, $sAppVersion), $iWidth, $iHeight, -1, -1)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseGui') ; beim schliessen des Fensters die Funktion _End() aufrufen
GUISetFont(9, 400, 0, 'Arial') ; Standard-Zeichensatz fuer ein Control-Element, wenn kein anderer Zeichensatz angegeben wurde
GUISetBkColor(0xDFDFDF) ; Hintergrundfarbe des Fensters
#EndRegion Fenster erstellen

#Region OSC Tickets
GUICtrlCreateGroup('OSC Tickets', 5, 20, 275, 475)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
Global $idTickets = GUICtrlCreateTreeView(10, 35, $iWidth - 540, $iHeight - 150, Default, $WS_EX_STATICEDGE)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
;~ GUICtrlSetBkColor(-1, 0xF8F8F8)
GUICtrlCreateGroup('', -99, -99, 1, 1) ; die Gruppe schliessen

GUICtrlCreateGroup('Legende', 5, 500, 275, 72)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
Global $aLegends[] = ['Normal', 'Erledigt', 'Reserviert', 'Wichtig'], $aIconID[] = [-100, -102, -103, -101], $iSize = 16
For $i = 0 To UBound($aLegends) - 1
	GUICtrlCreateLabel($aLegends[$i], 40 + Mod($i, 2) * 140, 522 + Int($i / 2) * 25, 80, 20)
	GUICtrlCreateIcon('imageres.dll', $aIconID[$i], 20 + Mod($i, 2) * 140, 522 + Int($i / 2) * 25, $iSize, $iSize)
Next
GUICtrlCreateGroup('', -99, -99, 1, 1) ; die Gruppe schliessen
#EndRegion OSC Tickets

#Region OSC Infos
Global $aidOSCinfos[8] ; 0=Markt, 1=Name KD, 2=Abteilung, 3=Telefon, 4=Belegnummer, 5=Reservierung, 6=Wichtig, 7 = Anliegen
GUICtrlCreateGroup('OSC Infos', 290, 20, 500, 125)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
GUICtrlCreateLabel('Markt:', 300, 40, 60, 18)
$aidOSCinfos[0] = GUICtrlCreateCombo('', 360, 38, 150, 18, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
GUICtrlSetData(-1, "MM Alex|MM Biesdorf|MM Brandenburg|MM Charlottenburg|MM Eiche|MM Gropius|MM HBF|MM HSH|MM Neukölln|MM Potsdam|MM Prenz'l Berg|MM Schöneweide|MM Schwedt|MM Spandau|MM Steglitz|MM Tegel|MM Tempelhof|MM Waltersdorf|MM Wedding", '')

GUICtrlCreateLabel('Name KD:', 540, 40, 60, 18)
$aidOSCinfos[1] = GUICtrlCreateInput('', 600, 38, 150, 18)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
GUICtrlCreateLabel('Abteilung:', 300, 70, 60, 18)
$aidOSCinfos[2] = GUICtrlCreateCombo('', 360, 68, 150, 18, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
GUICtrlSetData(-1, "BW TV|BW HiFi|BW Foto|BW Henkelware|BW Zubehör|BW Car-HiFi|Neue Medien|Computer|Zubehör|GSM|Bürokom|Navi, Outdoor|WW Großgeräte|WW Kleingeräte|Enternainment|Tonträger|Software|Service|eBay|Lager|Sicherheit", "")

GUICtrlCreateLabel('Telefon#:', 540, 70, 60, 18)
$aidOSCinfos[3] = GUICtrlCreateInput('', 600, 68, 150, 18)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
GUICtrlCreateLabel('Belegnummer/Auftragsnummer/Bestellnummer:', 420, 100, 300, 15)
$aidOSCinfos[4] = GUICtrlCreateInput('', 470, 120, 135, 18)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
$aidOSCinfos[5] = GUICtrlCreateCheckbox('Reserviert?', 615, 120, 80, 18)
$aidOSCinfos[6] = GUICtrlCreateCheckbox('Wichtig?', 710, 120, 70, 18)
GUICtrlCreateGroup('', -99, -99, 1, 1) ; die Gruppe schliessen
#EndRegion OSC Infos

#Region Anliegen
GUICtrlCreateGroup('Anliegen', 290, 150, 500, 80)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
$aidOSCinfos[7] = GUICtrlCreateEdit('', 300, 165, 480, 55, BitOR($WS_VSCROLL, $ES_MULTILINE, $ES_AUTOVSCROLL, $ES_WANTRETURN))
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlCreateGroup('', -99, -99, 1, 1) ; die Gruppe schliessen
#EndRegion Anliegen

Global $idTicketCreate = GUICtrlCreateButton('Eingabefelder löschen (neuer Fall)', 290, 236, 240, 25)
GUICtrlSetOnEvent(-1, '_TicketNew')
Global $idTicketCreate = GUICtrlCreateButton('OSC Fall erstellen (speichern)', 590, 236, 200, 25)
GUICtrlSetOnEvent(-1, '_TicketCreate')

#Region Nur fuer den OSC'ler
GUICtrlCreateGroup("Nur für den OSC'ler", 415, 270, 235, 52)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
Global $idTicketOk = GUICtrlCreateCheckbox('Erledigt', 430, 290, 80, 24)
Global $idTicketUpdate = GUICtrlCreateButton('Update OSC Fall', 520, 290, 120, 24)
GUICtrlSetOnEvent(-1, '_TicketUpdate')
GUICtrlCreateGroup('', -99, -99, 1, 1)
#EndRegion Nur fuer den OSC'ler

#Region Notizen
GUICtrlCreateGroup('Notizen', 290, 320, 500, 252)
GUICtrlSetFont(-1, 8, 600, 0, 'Verdana')
Global $idNotes = GUICtrlCreateEdit('', 300, 335, 480, 230, BitOR($WS_VSCROLL, $ES_MULTILINE));, $ES_READONLY))
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlCreateGroup('', -99, -99, 1, 1) ; die Gruppe schliessen
#EndRegion Notizen

#Region Statuszeile
Global $aParts[2] = [$iWidth / 2, -1]
Global $hStatus = _GUICtrlStatusBar_Create($hGui, $aParts)
#EndRegion Statuszeile

GUISetState()
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
_UpdateTicketTreeview()
WinWaitClose($hGui)

#Region Funktionen
Func _CloseGui()
	GUIDelete($hGui)
	Exit
EndFunc   ;==>_CloseGui

Func _WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam
	Local $tNMHDR, $tNMTREEVIEW, $hItem
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	Switch DllStructGetData($tNMHDR, 'IDFrom')
		Case $idTickets
			Switch DllStructGetData($tNMHDR, 'Code')
				Case $TVN_SELCHANGEDA, $TVN_SELCHANGEDW
					$tNMTREEVIEW = DllStructCreate($tagNMTREEVIEW, $lParam)
					$hItem = DllStructGetData($tNMTREEVIEW, 'NewhItem')
					If $hItem = 0 Then Return 1
					_TicketClick($hItem)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _TicketClick($hSelect) ; wenn auf einen Eintrag im Treeview geklickt wurde
	; Datei = $iNERW, $sMarkt, $sAbteilung, $sName, $sTelefon, $sBelegnummer, $sAnliegen, $sNotes
	; $aidOSCinfos[8] 0=Markt, 1=Name KD, 2=Abteilung, 3=Telefon, 4=Belegnummer, 5=Reservierung, 6=Wichtig, 7=Anliegen
	Local $sFilename, $sData, $aData
	$sFilename = _GUICtrlTreeView_GetText($idTickets, $hSelect) ; der Text (Dateiname) des Items
	$sData = FileRead($sMailerPath & $sFilename) ; die Daten aus der Datei lesen
	If $sData = '' Then Return
	$aData = StringSplit($sData, @CRLF, $STR_ENTIRESPLIT + $STR_NOCOUNT) ; am Zeilenende (@CRLF) splitten
	If Not IsArray($aData) Or UBound($aData) <> 9 Then Return
	; und die Daten in die Eingabefelder eintragen:
	If $aData[1] = '' Then
		_GUICtrlComboBox_SetCurSel($aidOSCinfos[0], -1)
	Else
		GUICtrlSetData($aidOSCinfos[0], $aData[1])
	EndIf
	GUICtrlSetData($aidOSCinfos[1], $aData[3])
	If $aData[2] = '' Then
		_GUICtrlComboBox_SetCurSel($aidOSCinfos[2], -1)
	Else
		GUICtrlSetData($aidOSCinfos[2], $aData[2])
	EndIf
	GUICtrlSetData($aidOSCinfos[3], $aData[4])
	GUICtrlSetData($aidOSCinfos[4], StringTrimRight($sFilename, 4))
	GUICtrlSetState($aidOSCinfos[5], (BitAND($aData[0], $OSC_RESERVIERT) ? $GUI_CHECKED : $GUI_UNCHECKED))
	GUICtrlSetState($aidOSCinfos[6], (BitAND($aData[0], $OSC_WICHTIG) ? $GUI_CHECKED : $GUI_UNCHECKED))
	GUICtrlSetState($idTicketOk, (BitAND($aData[0], $OSC_ELEDIGT) ? $GUI_CHECKED : $GUI_UNCHECKED))
	GUICtrlSetData($aidOSCinfos[7], $aData[6])
	GUICtrlSetData($idNotes, $aData[7])
EndFunc   ;==>_TicketClick

Func _DateSortedFileList(ByRef $aFiles, $sPath)
	Local $sTmp
	For $i = 1 To $aFiles[0] - 1
		For $j = $aFiles[0] To $i + 1 Step -1
			If FileGetTime($sPath & $aFiles[$j], 0, 1) > FileGetTime($sPath & $aFiles[$i], 0, 1) Then
				$sTmp = $aFiles[$i]
				$aFiles[$i] = $aFiles[$j]
				$aFiles[$j] = $sTmp
			EndIf
		Next
	Next
EndFunc   ;==>_DateSortedFileList

Func _UpdateTicketTreeview() ; zum aktualisieren des Treeviews
	; Const $OSC_NORMAL = 0, $OSC_ELEDIGT = 1, $OSC_RESERVIERT = 2, $OSC_WICHTIG = 4
	Local $aFiles, $idRoot, $idItem, $aidGroup[UBound($aLegends)], $iFlag
	$aFiles = _FileListToArrayRec($sMailerPath, '*.txt', $FLTAR_FILES + $FLTAR_NOHIDDEN + $FLTAR_NOSYSTEM + $FLTAR_NOLINK, $FLTAR_NORECUR, $FLTAR_NOSORT, $FLTAR_RELPATH)
	If @error Then Return
	_DateSortedFileList($aFiles, $sMailerPath) ; die Dateien nach Datum/Uhrzeit sortieren (letzte Dateiaenderung)
	_GUICtrlTreeView_BeginUpdate($idTickets)
	_GUICtrlTreeView_DeleteAll($idTickets)
	$idRoot = GUICtrlCreateTreeViewItem(StringRegExpReplace($sMailerPath, '.+\\(.+)\\', '$1'), $idTickets)
	_GUICtrlTreeView_SetIcon($idTickets, $idRoot, 'imageres.dll', 4) ; Icon fuer das oberste Item
	For $i = 0 To UBound($aidGroup) - 1
		$aidGroup[$i] = GUICtrlCreateTreeViewItem($aLegends[$i], $idRoot)
		_GUICtrlTreeView_SetIcon($idTickets, $aidGroup[$i], 'imageres.dll', 4) ; Icon fuer das oberste Item
	Next
	For $i = 1 To $aFiles[0]
		$iFlag = FileRead($sMailerPath & $aFiles[$i], 1) ; das Flag mit dem Status steht an erster Stelle der Datei (einstellig)
		Select ; hoechste Prioritaet nach oben und dann absteigend
			Case BitAND($iFlag, $OSC_ELEDIGT) = $OSC_ELEDIGT
				$idItem = GUICtrlCreateTreeViewItem($aFiles[$i], $aidGroup[1])
				_GUICtrlTreeView_SetIcon($idTickets, $idItem, 'imageres.dll', 101)
			Case BitAND($iFlag, $OSC_WICHTIG) = $OSC_WICHTIG
				$idItem = GUICtrlCreateTreeViewItem($aFiles[$i], $aidGroup[3])
				_GUICtrlTreeView_SetIcon($idTickets, $idItem, 'imageres.dll', 100)
			Case BitAND($iFlag, $OSC_RESERVIERT) = $OSC_RESERVIERT
				$idItem = GUICtrlCreateTreeViewItem($aFiles[$i], $aidGroup[2])
				_GUICtrlTreeView_SetIcon($idTickets, $idItem, 'imageres.dll', 102)
			Case BitAND($iFlag, $OSC_NORMAL) = $OSC_NORMAL
				$idItem = GUICtrlCreateTreeViewItem($aFiles[$i], $aidGroup[0])
				_GUICtrlTreeView_SetIcon($idTickets, $idItem, 'imageres.dll', 99)
		EndSelect
	Next
	_GUICtrlTreeView_EndUpdate($idTickets)
	For $idItem In $aidGroup
		GUICtrlSetState($idItem, $GUI_EXPAND)
	Next
	GUICtrlSetState($idRoot, $GUI_EXPAND)
EndFunc   ;==>_UpdateTicketTreeview

Func _TicketNew() ; zum loeschen der Eingabefelder
	; $aidOSCinfos[8] 0=Markt, 1=Name KD, 2=Abteilung, 3=Telefon, 4=Belegnummer, 5=Reservierung, 6=Wichtig, 7=Anliegen
	For $i = 0 To UBound($aidOSCinfos) - 1
		Switch $i
			Case 0, 2 ; Markt und Abteilung sind Combos (auf "Nichts ausgewaehlt" setzen)
				_GUICtrlComboBox_SetCurSel($aidOSCinfos[$i], -1)
			Case 5, 6 ; "Reservierung" und "Wichtig" sind Checkboxen (auf "unchecked" setzen)
				GUICtrlSetState($aidOSCinfos[$i], $GUI_UNCHECKED)
			Case Else ; alle anderen Eingabefelder koennen auf einen Leerstring gesetzt werden
				GUICtrlSetData($aidOSCinfos[$i], '')
		EndSwitch
	Next
EndFunc   ;==>_TicketNew

Func _TicketCreate() ; zum erstellen eines Falls (der Haken fuer "erledigt" und die Notizen werden hier !nicht! gespeichert)
	; $aidOSCinfos[8] 0=Markt, 1=Name KD, 2=Abteilung, 3=Telefon, 4=Belegnummer, 5=Reservierung, 6=Wichtig, 7=Anliegen
	; Const $OSC_NORMAL = 0, $OSC_ELEDIGT = 1, $OSC_RESERVIERT = 2, $OSC_WICHTIG = 4
	Local $sData, $iNERW, $sMarkt, $sName, $sAbteilung, $sTelefon, $sBelegnummer, $sAnliegen
	$iNERW = $OSC_NORMAL ; Normal-Flag als Standard setzen
	$iNERW += (BitAND(GUICtrlRead($aidOSCinfos[5]), $GUI_CHECKED) ? $OSC_RESERVIERT : 0) ; Reserviert-Flag addieren, falls Haken gesetzt
	$iNERW += (BitAND(GUICtrlRead($aidOSCinfos[6]), $GUI_CHECKED) ? $OSC_WICHTIG : 0) ; Wichtig-Flag addieren, falls Haken gesetzt
	; Daten aus den Eingabefeldern lesen
	$sMarkt = GUICtrlRead($aidOSCinfos[0])
	$sName = GUICtrlRead($aidOSCinfos[1])
	$sAbteilung = GUICtrlRead($aidOSCinfos[2])
	$sTelefon = GUICtrlRead($aidOSCinfos[3])
	$sBelegnummer = GUICtrlRead($aidOSCinfos[4])
	Switch $sBelegnummer
		Case '' ; wenn keine Belegnummer
			MsgBox($MB_ICONWARNING, 'Achtung!', StringFormat('Bitte eine Belegnummer/Bestellnummer/Auftragsnummer eintragen.\r\nWenn keine vorhanden ist bitte "keine" eintragen.'))
			Return
		Case 'keine' ; wenn "keine" eingetragen wurde
			; nichts tun
		Case Else ; bei allen anderen Eintraegen
			If FileExists($sMailerPath & $sBelegnummer & '.txt') Then
				MsgBox($MB_ICONWARNING, 'Achtung!', StringFormat("Ein Fall mit dieser Belegnummer/Bestellnummer/Auftragsnummer existiert bereits.\r\nÄnderungen können nur durch OSC'ler vorgenommen werden."))
				Return
			EndIf
	EndSwitch
	$sAnliegen = GUICtrlRead($aidOSCinfos[7])
	; die Daten in einen Ausgabestring zusammenfassen (jeweils mit @CRLF = "\r\n" abgeschlossen)
	$sData = StringFormat('%i\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n\r\n', $iNERW, $sMarkt, $sAbteilung, $sName, $sTelefon, $sBelegnummer, $sAnliegen)
	_WriteFile($sBelegnummer, $sData) ; die Daten in eine Datei schreiben
	_UpdateTicketTreeview() ; das Treeview aktualisieren
EndFunc   ;==>_TicketCreate

Func _TicketUpdate() ; zum aendern eines Falls (nur fuer OSC'ler: "erledigt" und Notizen werden gespeichert)
	; $aidOSCinfos[8] 0=Markt, 1=Name KD, 2=Abteilung, 3=Telefon, 4=Belegnummer, 5=Reservierung, 6=Wichtig, 7=Anliegen
	; Const $OSC_NORMAL = 0, $OSC_ELEDIGT = 1, $OSC_RESERVIERT = 2, $OSC_WICHTIG = 4
	Local $sData, $iNERW, $sMarkt, $sName, $sAbteilung, $sTelefon, $sBelegnummer, $sAnliegen, $sNotes
	$iNERW = $OSC_NORMAL ; Normal-Flag als Standard setzen
	$iNERW += (BitAND(GUICtrlRead($idTicketOk), $GUI_CHECKED) ? $OSC_ELEDIGT : 0) ; Erledigt-Flag addieren, falls Haken gesetzt
	$iNERW += (BitAND(GUICtrlRead($aidOSCinfos[5]), $GUI_CHECKED) ? $OSC_RESERVIERT : 0) ; Reserviert-Flag addieren, falls Haken gesetzt
	$iNERW += (BitAND(GUICtrlRead($aidOSCinfos[6]), $GUI_CHECKED) ? $OSC_WICHTIG : 0) ; Wichtig-Flag addieren, falls Haken gesetzt
	; Daten aus den Eingabefeldern lesen
	$sMarkt = GUICtrlRead($aidOSCinfos[0])
	$sName = GUICtrlRead($aidOSCinfos[1])
	$sAbteilung = GUICtrlRead($aidOSCinfos[2])
	$sTelefon = GUICtrlRead($aidOSCinfos[3])
	$sBelegnummer = GUICtrlRead($aidOSCinfos[4])
	If $sBelegnummer = '' Then
		MsgBox($MB_ICONWARNING, 'Achtung!', StringFormat('Bitte eine Belegnummer/Bestellnummer/Auftragsnummer eintragen.\r\nWenn keine vorhanden ist bitte "keine" eintragen.'))
		Return
	EndIf
	$sAnliegen = GUICtrlRead($aidOSCinfos[7])
	$sNotes = GUICtrlRead($idNotes)
	; die Daten in einen Ausgabestring zusammenfassen (jeweils mit @CRLF = "\r\n" abgeschlossen)
	$sData = StringFormat('%i\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n', $iNERW, $sMarkt, $sAbteilung, $sName, $sTelefon, $sBelegnummer, $sAnliegen, $sNotes)
	_WriteFile($sBelegnummer, $sData, True) ; die Daten in die Datei schreiben (ueberschreiben)
	_UpdateTicketTreeview() ; das Treeview aktualisieren
EndFunc   ;==>_TicketUpdate

Func _WriteFile($sBelegnummer, $sData, $bOverwrite = False)
	Local $hFile, $sFilename = $sMailerPath & $sBelegnummer & '.txt'
	If Not $bOverwrite Then $sFilename = _GetUniqueFileName($sFilename) ; sicherstellen, dass der Dateiname einmalig ist
	$hFile = FileOpen($sFilename, $FO_OVERWRITE) ; Datei zum ueberschreiben oeffnen
	If $hFile <> -1 Then ; wenn die Datei zum schreiben geoeffnet werden konnte, dann...
		FileWrite($hFile, $sData) ; die Daten in die Datei schreiben
		FileClose($hFile) ; und die Datei wieder schliessen
	EndIf
EndFunc   ;==>_WriteFile

;===============================================================================
; Function Name:   _GetUniqueFileName($sPath)
; Description::    Wenn der Dateiname bereits existiert wird ein Zähler
;                  in Form von: " (1)" an den Dateinamen angehängt.
; Parameter(s):    $sPath = kompletter Pfad der Datei
; Requirement(s):  -
; Return Value(s): bei Erfolg = der (neue) Dateiname
;                  bei Fehler wird @error = 1 (Pfad falsch angegeben)
; Author(s):       Oscar (www.autoit.de)
;===============================================================================
Func _GetUniqueFileName($sPath)
	Local $aPath, $sNumber = '', $iCount = 0
	$aPath = StringRegExp($sPath, '(.+\\)(.+)(?: \(\d*\))*(\..+)', 3)
	If @error Then Return SetError(1, 0, 0)
	While FileExists($aPath[0] & $aPath[1] & $sNumber & $aPath[2])
		$iCount += 1
		$sNumber = ' (' & $iCount & ')'
	WEnd
	Return $aPath[0] & $aPath[1] & $sNumber & $aPath[2]
EndFunc   ;==>_GetUniqueFileName
#EndRegion Funktionen
